package com.muyu.marketing.domain.resp;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.muyu.marketing.domain.model.ActivityTeamInfoProductSkuDetailModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Date;
import java.util.List;

/**
 * @program: 2204a-cloud-server
 * @description: 团购活动商品信息规格表
 * @author: MengFanKuo
 * @create: 2024-11-26 14:22
 * *
 */
@Data
@AllArgsConstructor
@SuperBuilder
@NoArgsConstructor
public class ActivityTeamInfoProductSkuDetailResp {
    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private long id;
    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private long productId;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位
     */
    private String unit;
    /**
     * 轮播图
     */
    private String imageList;
    /**
     * 活动结束时间
     */
    private Date endTime;
    /**
     * 活动排序
     */
    private long sort;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private long strategyId;
    /**
     * 规格
     */
    private List<ActivityTeamSkuInfoDetail> projectSkuInfoEachRespList;
    public static ActivityTeamInfoProductSkuDetailResp productSkuDetailBuild(ActivityTeamInfoProductSkuDetailModel activityTeamInfoProductSkuDetailModel){
       return ActivityTeamInfoProductSkuDetailResp.builder()
                .id(activityTeamInfoProductSkuDetailModel.getId())
                .productImage(activityTeamInfoProductSkuDetailModel.getProductImage())
                .productId(activityTeamInfoProductSkuDetailModel.getProductId())
                .name(activityTeamInfoProductSkuDetailModel.getName())
                .endTime(activityTeamInfoProductSkuDetailModel.getEndTime())
                .content(activityTeamInfoProductSkuDetailModel.getContent())
                .imageList(activityTeamInfoProductSkuDetailModel.getImageList())
                .introduction(activityTeamInfoProductSkuDetailModel.getIntroduction())
                .projectSkuInfoEachRespList(activityTeamInfoProductSkuDetailModel.getProjectSkuInfoAddReqList().stream().map(activityTeamSkuInfoDetailModel -> {
                   return ActivityTeamSkuInfoDetail.infoDetailBuild(activityTeamSkuInfoDetailModel);
                }).toList())
                .sort(activityTeamInfoProductSkuDetailModel.getSort())
                .strategyId(activityTeamInfoProductSkuDetailModel.getStrategyId())
                .strategyType(activityTeamInfoProductSkuDetailModel.getStrategyType())
                .unit(activityTeamInfoProductSkuDetailModel.getUnit())
                .build();
    }
}
